Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.dbf/src/main/java/org/gvsig/fmap/dal/store/dbf/DBFLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.dbf/src/main/java/org/gvsig/fmap/dal/store/dbf/DBFLibrary.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.dbf/src/main/java/org/gvsig/fmap/dal/store/dbf/DBFLibrary.java	(revision 43920)
@@ -66,7 +66,7 @@
 
 	@Override
 	protected void doPostInitialize() throws LibraryException {
-		List<Throwable> exs = new ArrayList<Throwable>();
+		List<Throwable> exs = new ArrayList<>();
 
 		FileHelper.registerParametersDefinition(
 				DBFStoreParameters.PARAMETERS_DEFINITION_NAME,

Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.exportto.app/org.gvsig.exportto.app.mainplugin/src/main/java/org/gvsig/exportto/app/extension/ExporttoTableExtension.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.exportto.app/org.gvsig.exportto.app.mainplugin/src/main/java/org/gvsig/exportto/app/extension/ExporttoTableExtension.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.exportto.app/org.gvsig.exportto.app.mainplugin/src/main/java/org/gvsig/exportto/app/extension/ExporttoTableExtension.java	(revision 43920)
@@ -76,13 +76,12 @@
     private void showExportto(FeatureStore featureStore) {
         I18nManager i18nManager = ToolsLocator.getI18nManager();
         
-        JExporttoServicePanel panel =
-            swingManager
-                .createExportto(
-                    featureStore,
-                    null,
-                    new LoadTableAction(),
-                    new int[] { ExporttoSwingManager.VECTORIAL_TABLE_WITHOUT_GEOMETRY });
+        JExporttoServicePanel panel = swingManager.createExportto(
+            featureStore,
+            null,
+            new LoadTableAction(),
+            null //new int[] { ExporttoSwingManager.VECTORIAL_TABLE_WITHOUT_GEOMETRY, ExporttoSwingManager.VECTORIAL_TABLE_WITH_GEOMETRY }
+        );
 
         swingManager.getWindowManager().showWindow(panel, i18nManager.getTranslation("_Export_to"),
             ExporttoWindowManager.MODE_WINDOW);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/exportto/impl/AttributeNamesTranslator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/exportto/impl/AttributeNamesTranslator.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.lib/org.gvsig.exportto.lib.impl/src/main/java/org/gvsig/exportto/impl/AttributeNamesTranslator.java	(revision 43920)
@@ -37,6 +37,7 @@
          return this.targetToSource.getOrDefault(name, name);
     }
     
+    @Override
     public Iterator<String> iterator() {
         return this.sourceToTarget.keySet().iterator();
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/AbstractExporttoSwingProvider.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/AbstractExporttoSwingProvider.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/AbstractExporttoSwingProvider.java	(revision 43920)
@@ -0,0 +1,60 @@
+package org.gvsig.exportto.swing.spi;
+
+import org.gvsig.exportto.swing.spi.options.ExportOptions;
+import org.gvsig.exportto.swing.spi.options.BaseExportGeometryOptions;
+import java.util.ArrayList;
+import java.util.List;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.tools.service.spi.AbstractProvider;
+import org.gvsig.tools.service.spi.ProviderServices;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public abstract class AbstractExporttoSwingProvider 
+        extends AbstractProvider
+        implements ExporttoSwingProvider 
+    {
+    
+    protected ExportOptions options;
+    private final List<ExporttoSwingProviderPanel> panels;
+    
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    protected AbstractExporttoSwingProvider(
+            ProviderServices providerServices,
+            FeatureStore featureStore
+        ) {
+        super(providerServices);
+        this.panels = new ArrayList<>();
+        this.getOptions().setSourceFeatureStore(featureStore);
+    }
+    
+    @Override
+    public ExportOptions getOptions() {
+        if( this.options == null ) {
+            this.options = new BaseExportGeometryOptions();                    
+        }
+        return this.options;
+    }
+    
+    protected void panelAdd(ExporttoSwingProviderPanel panel) {
+        this.panels.add(panel);
+    }
+    
+    @Override
+    public int getPanelCount() {
+        return this.panels.size();
+    }
+
+    @Override
+    public ExporttoSwingProviderPanel getPanelAt(int index) {
+        return this.panels.get(index);
+    }
+
+    @Override
+    public boolean needsPanelTargetProjection() {
+        return false;
+    }
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportOptions.java	(revision 43920)
@@ -0,0 +1,78 @@
+package org.gvsig.exportto.swing.spi.options;
+
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.tools.evaluator.Evaluator;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class BaseExportOptions implements ExportOptions {
+
+    private FeatureType sourceFeatureType;
+    private FeatureStore sourceFeatureStore;
+    private Evaluator filter;
+    private String filterName;
+    private String filterExpression;
+
+    @Override
+    public FeatureType getSourceFeatureType() {
+        return this.sourceFeatureType;
+    }
+    
+    @Override
+    public void setSourceFeatureType(FeatureType sourceFeatureType) {
+        this.sourceFeatureType = sourceFeatureType;
+    }
+    
+    @Override
+    public void setSourceFeatureStore(FeatureStore sourceFeatureStore) {
+        this.sourceFeatureStore = sourceFeatureStore;
+        if( this.sourceFeatureType==null ) {
+            try {
+                this.sourceFeatureType = sourceFeatureStore.getDefaultFeatureType();
+            } catch (DataException ex) {
+                throw new RuntimeException("Can't get feature type", ex);
+            }
+        }
+    }
+
+    @Override
+    public FeatureStore getSourceFeatureStore() {
+        return this.sourceFeatureStore;
+    }
+
+    @Override
+    public Evaluator getFilter() {
+        return this.filter;
+    }
+
+    @Override
+    public String getFilterExpresion() {
+        return this.filterExpression;
+    }
+
+    @Override
+    public String getFilterName() {
+        return this.filterName;
+    }
+
+    @Override
+    public void setFilter(Evaluator filter) {
+        this.filter = filter;
+    }
+
+    @Override
+    public void setFilterExpresion(String expression) {
+        this.filterExpression = expression;
+    }
+
+    @Override
+    public void setFilterName(String name) {
+        this.filterName = name;
+    }
+    
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportGeometryOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportGeometryOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportGeometryOptions.java	(revision 43920)
@@ -0,0 +1,54 @@
+package org.gvsig.exportto.swing.spi.options;
+
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.geom.type.GeometryType;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public interface ExportGeometryOptions extends ExportOptions {
+    
+    public static final int CHECKGEOMETRY_NONE = 0;
+    public static final int CHECKGEOMETRY_CHECK_IF_CORRUPT = 1;
+    public static final int CHECKGEOMETRY_CHECK_IF_VALID = 2;
+
+    public static final int CHECKGEOMETRYACTION_SET_GEOMETRY_TO_NULL = 0;
+    public static final int CHECKGEOMETRYACTION_SKIP_FEATURE = 1;
+    public static final int CHECKGEOMETRYACTION_ABORT = 2;
+    
+
+    public void setTargetProjection(IProjection targetProjection);
+
+    public IProjection getTargetProjection();
+
+    public boolean needsPanelTargetProjection();
+
+    public int getGeometryChecks();
+
+    public int getGeometryChecksAction();
+
+    public boolean getTryToFixGeometry();
+
+    public void setGeometryChecks(int geometryChecks);
+
+    public void setGeometryChecksAction(int geometryChecksAction);
+
+    public void setTryToFixGeometry(boolean tryToFixGeometry);
+    
+    public String getGeometryFieldName();
+    
+    public void setGeometryFieldName(String geometryFieldName);
+    
+    public GeometryType getGeometryType();
+    
+    public int getGeometryTypeAsInt();
+    
+    public int getGeometrySubtype();
+    
+    public void setGeometryType(GeometryType type);
+    
+    public void setGeometryType(int type);
+    
+    public void setGeometrySubtype(int subtype);
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/ExportOptions.java	(revision 43920)
@@ -0,0 +1,37 @@
+package org.gvsig.exportto.swing.spi.options;
+
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.DataManager;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.tools.evaluator.Evaluator;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public interface ExportOptions {
+
+    public FeatureType getSourceFeatureType();
+    
+    public void setSourceFeatureType(FeatureType sourceFeatureType);
+    
+    public void setSourceFeatureStore(FeatureStore sourceFeatureStore);
+    
+    public FeatureStore getSourceFeatureStore();
+    
+    public Evaluator getFilter();
+    
+    public String getFilterExpresion();
+
+    public String getFilterName();
+    
+    public void setFilter(Evaluator filter);
+    
+    public void setFilterExpresion(String expression);
+
+    public void setFilterName(String name);
+    
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportGeometryOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportGeometryOptions.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/options/BaseExportGeometryOptions.java	(revision 43920)
@@ -0,0 +1,127 @@
+/*
+ * To change this license header, choose License Headers in Project Properties.
+ * To change this template file, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.gvsig.exportto.swing.spi.options;
+
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.geom.GeometryLocator;
+import org.gvsig.fmap.geom.GeometryManager;
+import org.gvsig.fmap.geom.type.GeometryType;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class BaseExportGeometryOptions 
+        extends BaseExportOptions
+        implements ExportGeometryOptions 
+    {
+
+    protected IProjection projection;
+    private int geometryChecks;
+    private int geometryChecksAction;
+    private boolean tryToFixGeometry;
+    private String geometryFieldName;
+    private int geometryType;
+    private int geometrySubtype;
+        
+    @Override
+    public boolean needsPanelTargetProjection() {
+        return false;
+    }    
+
+    @Override
+    public void setTargetProjection(IProjection targetProjection) {
+        this.projection = targetProjection;
+    }
+
+    @Override
+    public IProjection getTargetProjection() {
+        return this.projection;
+    }
+
+    @Override
+    public int getGeometryChecks() {
+        return this.geometryChecks;
+    }
+
+    @Override
+    public int getGeometryChecksAction() {
+        return this.geometryChecksAction;
+    }
+
+    @Override
+    public boolean getTryToFixGeometry() {
+        return this.tryToFixGeometry;
+    }
+
+    @Override
+    public void setGeometryChecks(int geometryChecks) {
+        this.geometryChecks = geometryChecks;
+    }
+
+    @Override
+    public void setGeometryChecksAction(int geometryChecksAction) {
+        this.geometryChecksAction = geometryChecksAction;
+    }
+
+    @Override
+    public void setTryToFixGeometry(boolean tryToFixGeometry) {
+        this.tryToFixGeometry = tryToFixGeometry;
+    }
+
+    @Override
+    public String getGeometryFieldName() {
+        return this.geometryFieldName;
+    }
+
+    @Override
+    public void setGeometryFieldName(String geometryFieldName) {
+        this.geometryFieldName = geometryFieldName;
+    }
+
+    @Override
+    public int getGeometryTypeAsInt() {
+        return geometryType;
+    }
+
+    @Override
+    public int getGeometrySubtype() {
+        return geometrySubtype;
+    }
+
+    @Override
+    public void setGeometryType(int geometryType) {
+        this.geometryType = geometryType;
+    }
+
+    @Override
+    public void setGeometrySubtype(int subtype) {
+        this.geometrySubtype = subtype;
+    }
+
+    @Override
+    public void setGeometryType(GeometryType type) {
+        this.geometryType = type.getType();
+        this.geometrySubtype = type.getSubType();
+    }
+
+    @Override
+    public GeometryType getGeometryType() {
+        try {
+            GeometryManager geomManager = GeometryLocator.getGeometryManager();
+            GeometryType type = geomManager.getGeometryType(
+                    geometryType,
+                    geometryType
+            );
+            return type;
+        } catch (Exception ex) {
+            throw new RuntimeException("Can't create geoemtry type from type "+geometryType+", subtype "+geometrySubtype+".", ex);
+        }
+    }
+
+
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/ExportGeometryUtils.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/ExportGeometryUtils.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/ExportGeometryUtils.java	(revision 43920)
@@ -0,0 +1,138 @@
+package org.gvsig.exportto.swing.spi;
+
+import org.gvsig.exportto.swing.spi.options.ExportGeometryOptions;
+import org.cresques.cts.ICoordTrans;
+import org.gvsig.fmap.geom.Geometry;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class ExportGeometryUtils {
+
+    public static class FixGeometryStatus {
+
+        public static final int STATE_OK = 0;
+        public static final int STATE_SKIP = 1;
+        public static final int STATE_ABORT = 2;
+
+        private Geometry geometry;
+        private final int state;
+        private String message;
+
+        public FixGeometryStatus(Geometry geometry, int state) {
+            this.geometry = geometry;
+            this.state = state;
+        }
+
+        public FixGeometryStatus(Geometry geometry) {
+            this.geometry = geometry;
+            this.state = STATE_OK;
+        }
+
+        public FixGeometryStatus(int state) {
+            this.geometry = null;
+            this.state = state;
+        }
+
+        public FixGeometryStatus(int state, String message) {
+            this.geometry = null;
+            this.state = state;
+            this.message = message;
+        }
+
+        private void setGeometry(Geometry geometry) {
+            this.geometry = geometry;
+        }
+
+        public Geometry getGeometry() {
+            return this.geometry;
+        }
+
+        public int getState() {
+            return state;
+        }
+
+        public String getMessage() {
+            return this.message;
+        }
+
+    }
+
+    public static FixGeometryStatus fixGeometry(
+            ExportGeometryOptions options,
+            ICoordTrans coord_trans,
+            Geometry geometry
+    ) {
+        Geometry.ValidationStatus geometryCheck;
+        FixGeometryStatus status;
+
+        if (geometry == null) {
+            return new FixGeometryStatus(geometry);
+        }
+        switch (options.getGeometryChecks()) {
+            case ExportGeometryOptions.CHECKGEOMETRY_CHECK_IF_CORRUPT:
+                geometryCheck = geometry.getValidationStatus();
+                if (geometryCheck.isValid()) {
+                    status = new FixGeometryStatus(geometry);
+                    break;
+                }
+                switch (options.getGeometryChecksAction()) {
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_SET_GEOMETRY_TO_NULL:
+                        status = new FixGeometryStatus(null);
+                        break;
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_SKIP_FEATURE:
+                        status = new FixGeometryStatus(FixGeometryStatus.STATE_SKIP, geometryCheck.getMessage());
+                        break;
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_ABORT:
+                    default:
+                        status = new FixGeometryStatus(FixGeometryStatus.STATE_ABORT, geometryCheck.getMessage());
+                        break;
+                }
+                break;
+
+            case ExportGeometryOptions.CHECKGEOMETRY_CHECK_IF_VALID:
+                geometryCheck = geometry.getValidationStatus();
+                if (geometryCheck.isValid()) {
+                    status = new FixGeometryStatus(geometry);
+                    break;
+                }
+                Geometry g;
+                if (options.getTryToFixGeometry()) {
+                    g = geometry.makeValid();
+                    if (g != null) {
+                        status = new FixGeometryStatus(g);
+                        break;
+                    }
+                }
+                switch (options.getGeometryChecksAction()) {
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_SET_GEOMETRY_TO_NULL:
+                        status = new FixGeometryStatus(null);
+                        break;
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_SKIP_FEATURE:
+                        status = new FixGeometryStatus(FixGeometryStatus.STATE_SKIP, geometryCheck.getMessage());
+                        break;
+                    case ExportGeometryOptions.CHECKGEOMETRYACTION_ABORT:
+                    default:
+                        status = new FixGeometryStatus(FixGeometryStatus.STATE_ABORT, geometryCheck.getMessage());
+                        break;
+                }
+                break;
+
+            case ExportGeometryOptions.CHECKGEOMETRY_NONE:
+            default:
+                status = new FixGeometryStatus(geometry);
+                break;
+        }
+        if (coord_trans != null) {
+            if (status.getState() == FixGeometryStatus.STATE_OK) {
+                if (status.getGeometry() != null) {
+                    Geometry reproj_geom = status.getGeometry().cloneGeometry();
+                    reproj_geom.reProject(coord_trans);
+                    status.setGeometry(reproj_geom);
+                }
+            }
+        }
+        return status;
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/panels/SelectOutputFilePanelView.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/panels/SelectOutputFilePanelView.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.spi/src/main/java/org/gvsig/exportto/swing/spi/panels/SelectOutputFilePanelView.java	(revision 43920)
@@ -0,0 +1,148 @@
+package org.gvsig.exportto.swing.spi.panels;
+
+import com.jeta.open.i18n.I18NUtils;
+import com.jgoodies.forms.layout.CellConstraints;
+import com.jgoodies.forms.layout.FormLayout;
+import java.awt.BorderLayout;
+import java.awt.ComponentOrientation;
+import java.awt.Container;
+import java.awt.Dimension;
+import javax.swing.Box;
+import javax.swing.ImageIcon;
+import javax.swing.JButton;
+import javax.swing.JFrame;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JTextField;
+import javax.swing.border.EmptyBorder;
+
+
+public class SelectOutputFilePanelView extends JPanel
+{
+   JLabel lblFile = new JLabel();
+   JTextField txtFile = new JTextField();
+   JButton btnSelectFile = new JButton();
+
+   /**
+    * Default constructor
+    */
+   public SelectOutputFilePanelView()
+   {
+      initializePanel();
+   }
+
+   /**
+    * Adds fill components to empty cells in the first row and first column of the grid.
+    * This ensures that the grid spacing will be the same as shown in the designer.
+    * @param cols an array of column indices in the first row where fill components should be added.
+    * @param rows an array of row indices in the first column where fill components should be added.
+    */
+   void addFillComponents( Container panel, int[] cols, int[] rows )
+   {
+      Dimension filler = new Dimension(10,10);
+
+      boolean filled_cell_11 = false;
+      CellConstraints cc = new CellConstraints();
+      if ( cols.length > 0 && rows.length > 0 )
+      {
+         if ( cols[0] == 1 && rows[0] == 1 )
+         {
+            /** add a rigid area  */
+            panel.add( Box.createRigidArea( filler ), cc.xy(1,1) );
+            filled_cell_11 = true;
+         }
+      }
+
+      for( int index = 0; index < cols.length; index++ )
+      {
+         if ( cols[index] == 1 && filled_cell_11 )
+         {
+            continue;
+         }
+         panel.add( Box.createRigidArea( filler ), cc.xy(cols[index],1) );
+      }
+
+      for( int index = 0; index < rows.length; index++ )
+      {
+         if ( rows[index] == 1 && filled_cell_11 )
+         {
+            continue;
+         }
+         panel.add( Box.createRigidArea( filler ), cc.xy(1,rows[index]) );
+      }
+
+   }
+
+   /**
+    * Helper method to load an image file from the CLASSPATH
+    * @param imageName the package and name of the file to load relative to the CLASSPATH
+    * @return an ImageIcon instance with the specified image file
+    * @throws IllegalArgumentException if the image resource cannot be loaded.
+    */
+   public ImageIcon loadImage( String imageName )
+   {
+      try
+      {
+         ClassLoader classloader = getClass().getClassLoader();
+         java.net.URL url = classloader.getResource( imageName );
+         if ( url != null )
+         {
+            ImageIcon icon = new ImageIcon( url );
+            return icon;
+         }
+      }
+      catch( Exception e )
+      {
+         e.printStackTrace();
+      }
+      throw new IllegalArgumentException( "Unable to load image: " + imageName );
+   }
+
+   /**
+    * Method for recalculating the component orientation for 
+    * right-to-left Locales.
+    * @param orientation the component orientation to be applied
+    */
+   public void applyComponentOrientation( ComponentOrientation orientation )
+   {
+      // Not yet implemented...
+      // I18NUtils.applyComponentOrientation(this, orientation);
+      super.applyComponentOrientation(orientation);
+   }
+
+   public JPanel createPanel()
+   {
+      JPanel jpanel1 = new JPanel();
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:GROW(1.0),FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE,CENTER:DEFAULT:NONE");
+      CellConstraints cc = new CellConstraints();
+      jpanel1.setLayout(formlayout1);
+
+      lblFile.setName("lblFile");
+      lblFile.setText("_File");
+      jpanel1.add(lblFile,cc.xy(2,2));
+
+      txtFile.setName("txtFile");
+      jpanel1.add(txtFile,cc.xy(4,2));
+
+      btnSelectFile.setActionCommand("...");
+      btnSelectFile.setName("btnSelectFile");
+      btnSelectFile.setText("...");
+      EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
+      btnSelectFile.setBorder(emptyborder1);
+      jpanel1.add(btnSelectFile,cc.xy(6,2));
+
+      addFillComponents(jpanel1,new int[]{ 1,2,3,4,5,6,7 },new int[]{ 1,2,3 });
+      return jpanel1;
+   }
+
+   /**
+    * Initializer
+    */
+   protected void initializePanel()
+   {
+      setLayout(new BorderLayout());
+      add(createPanel(), BorderLayout.CENTER);
+   }
+
+
+}
